Debian Bug report logs - #457634
xterm: incorrect display when left-to-right mark output in bold mode

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: Vincent Lefevre <vincent@vinc17.org>

Date: Mon, 24 Dec 2007 01:33:01 UTC

Severity: normal

Tags: fixed-upstream

Found in version xterm/229-1

Fixed in version xterm/230-1

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#457634; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: incorrect display when left-to-right mark output in bold mode
Date: Mon, 24 Dec 2007 02:30:45 +0100
[Message part 1 (text/plain, inline)]
Package: xterm
Version: 229-1
Severity: normal

When the left-to-right mark[*] is output in bold mode, uxterm displays
a replacement character over the previous character. For instance, try
the following in a uxterm:

  printf '\u200e)foo %s)\u200efoo\n' "`tput bold`"

See attached snapshot.

[*] http://en.wikipedia.org/wiki/Left-to-right_mark

-- System Information:
Debian Release: lenny/sid
  APT prefers testing
  APT policy: (900, 'testing'), (900, 'stable'), (200, 'unstable')
Architecture: powerpc (ppc)

Kernel: Linux 2.6.18-5-powerpc
Locale: LANG=POSIX, LC_CTYPE=en_US.ISO8859-1 (charmap=ISO-8859-1)
Shell: /bin/sh linked to /bin/bash

Versions of packages xterm depends on:
ii  libc6                     2.7-4          GNU C Library: Shared libraries
ii  libfontconfig1            2.4.2-1.2      generic font configuration library
ii  libice6                   2:1.0.4-1      X11 Inter-Client Exchange library
ii  libncurses5               5.6+20071124-1 Shared libraries for terminal hand
ii  libsm6                    2:1.0.3-1+b1   X11 Session Management library
ii  libx11-6                  2:1.0.3-7      X11 client-side library
ii  libxaw7                   2:1.0.4-1      X11 Athena Widget library
ii  libxext6                  1:1.0.3-2      X11 miscellaneous extension librar
ii  libxft2                   2.1.12-2       FreeType-based font drawing librar
ii  libxmu6                   1:1.0.3-1      X11 miscellaneous utility library
ii  libxt6                    1:1.0.5-3      X11 toolkit intrinsics library
ii  xbitmaps                  1.0.1-2        Base X bitmaps

Versions of packages xterm recommends:
ii  xutils                      1:7.1.ds.3-1 X Window System utility programs

-- no debconf information
[lrm-bold.png (image/png, attachment)]

Message sent on to Vincent Lefevre <vincent@vinc17.org>:
Bug#457634. Full text and rfc822 format available.

Message #8 received at 457634-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 457634-submitter@bugs.debian.org
Subject: re: #457634 - xterm: incorrect display when left-to-right mark output in bold mode
Date: Sun, 30 Dec 2007 13:12:19 -0500
[Message part 1 (text/plain, inline)]
xterm is seeing the result from wcwidth(0x200e) as zero, and treating it as
a combining character.  Interestingly enough, iswprint() asserts that
it is printable, and iswcntrl() that it is not a control character though

	http://en.wikipedia.org/wiki/Unicode_control_characters

seems to have a different opinion.

If it is really a control character (which xterm does not recognize),
it should be ignored altogether.  But that would be less friendly than
trying to display a glyph (I propose to do the latter, for the time being).

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Information stored:
Bug#457634; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and filed, but not forwarded. Full text and rfc822 format available.

Message #13 received at 457634-quiet@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: dickey@his.com, 457634-quiet@bugs.debian.org
Cc: 457634-submitter@bugs.debian.org
Subject: Re: Bug#457634: #457634 - xterm: incorrect display when left-to-right mark output in bold mode
Date: Mon, 31 Dec 2007 01:42:57 +0100
On 2007-12-30 13:12:19 -0500, Thomas Dickey wrote:
> xterm is seeing the result from wcwidth(0x200e) as zero, and treating it as
> a combining character.  Interestingly enough, iswprint() asserts that
> it is printable, and iswcntrl() that it is not a control character though
> 
> 	http://en.wikipedia.org/wiki/Unicode_control_characters
> 
> seems to have a different opinion.
> 
> If it is really a control character (which xterm does not recognize),
> it should be ignored altogether.  But that would be less friendly than
> trying to display a glyph (I propose to do the latter, for the time being).

According to the Unicode database:

  200E;LEFT-TO-RIGHT MARK;Cf;0;L;;;;;N;;;;;

where "Cf" means[*]: Other, Format.

[*] http://unicode.org/Public/UNIDATA/UCD.html

So, from the Unicode point of view, it is not a control character,
but a formatting character. But the C standard does not have a
notion of formatting character; it just says:

       7.25.2  Wide-character classification utilities

       [#2] The term printing wide character refers to a member  of
       a  locale-specific  set  of  wide  characters, each of which
       occupies at least one printing position on a display device.
       The  term  control  wide  character  refers to a member of a
       locale-specific set of wide characters that are not printing
       wide characters.

So, it seems that this is really implementation-defined (but I don't
understand what is meant by "occupies at least one printing position
on a display device", e.g. what about combining characters, and
formatting characters such as the LRM and the BOM?).

FYI, under Mac OS X 10.4.11:

Property alnum : no
Property alpha : no
Property cntrl : yes
Property digit : no
Property graph : no
Property lower : no
Property print : no
Property punct : no
Property space : no
Property upper : no
Property xdigit: no
wcwidth = -1

Also note that gnome-terminal doesn't have any problem on Debian.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)




Message sent on to Vincent Lefevre <vincent@vinc17.org>:
Bug#457634. Full text and rfc822 format available.

Tags added: fixed-upstream Request was from Thomas Dickey <dickey@his.com> to control@bugs.debian.org. (Tue, 01 Jan 2008 18:03:09 GMT) Full text and rfc822 format available.

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Vincent Lefevre <vincent@vinc17.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #23 received at 457634-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 457634-close@bugs.debian.org
Subject: Bug#457634: fixed in xterm 230-1
Date: Thu, 03 Jan 2008 13:32:10 +0000
Source: xterm
Source-Version: 230-1

We believe that the bug you reported is fixed in the latest version of
xterm, which is due to be installed in the Debian FTP archive:

xterm_230-1.diff.gz
  to pool/main/x/xterm/xterm_230-1.diff.gz
xterm_230-1.dsc
  to pool/main/x/xterm/xterm_230-1.dsc
xterm_230-1_i386.deb
  to pool/main/x/xterm/xterm_230-1_i386.deb
xterm_230.orig.tar.gz
  to pool/main/x/xterm/xterm_230.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 457634@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xterm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Thu, 03 Jan 2008 12:07:38 +0100
Source: xterm
Binary: xterm
Architecture: source i386
Version: 230-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xterm      - X terminal emulator
Closes: 441354 449227 456236 457634
Changes: 
 xterm (230-1) unstable; urgency=low
 .
   * New upstream release.
     + do not treat Unicode BIDI control characters as combining characters
       (closes: #457634)
     + correct width-calculation used for adjusting proportional fonts, to work
       with wide-characters (closes: #441354)
     + make missing double-width glyphs display as double-width
       (closes: #456236)
     + fix an ifdef in logic for selecting regular expressions while in a
       narrow-character locale (closes: #449227)
   * koi8rxterm, its manpage and app-defaults file, and the uxterm manpage are
     now upstream, so remove our versions.
   * Bump Standards-Version to 3.7.3 (no changes).
   * Update copy of XTerm FAQ to revision 1.99 (dated 2007-11-29).
Files: 
 82d55dd59fd4392f9fd726fec94ec361 805 x11 optional xterm_230-1.dsc
 c1a654a6793aff285b69c1d1ed4f2c38 850697 x11 optional xterm_230.orig.tar.gz
 06e5f4e6398afa5b418a4c8dab85a072 61537 x11 optional xterm_230-1.diff.gz
 052b08e9828afec30c91856db7d3a33f 462132 x11 optional xterm_230-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFHfOA1mEvTgKxfcAwRAgYpAKCPINcLlLHUGqKNYrmXDGHDssm09wCcDw96
evTwPAu41iOpI31AGKu0dgk=
=jCKb
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 04 Feb 2008 07:28:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 10:12:26 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.